#include <iostream>
#include <queue>
#include <vector>

// Funkcijski objetak koji koristimo za poredjenje 2 objekta
struct compare
{
    compare(){}

    // Kreireamo max heap
    // Za min heap bi trebalo koristiti x > y
    bool operator()(int x, int y) {
        return x < y;
    }
};

int main ()
{
    std::vector<int> a = {3,2,1,5,7,4,6};

    // Kreiramo heap, odnosno red sa prioritetom. Prvi argument predstavlja tip podataka koji cuvamo,
    // drugi odgovara strukturi koja se u pozadini koristi za implementaciju strukture i treci predstavlja
    // komparator
    std::priority_queue<int, std::vector<int>, compare> heap;

    // Dodajemo element u heap
    for (int x : a)
        heap.push(x);

    // Skidamo elemente sa vrha heap-a i kako je max heap u pitanju, elementi se skidaju u opadajucem poretku
    // Ako zelimo da dobijemo elemente u rastucem poretku, treba da ih smestamo od kraja niza ka pocetku
    for (int i = a.size() - 1; i >= 0; i--) {
        a[i] = heap.top();
        heap.pop();
    }

    // Ispisujemo elemente u sortiranom nizu
    for (int x : a)
        std::cout << x << " ";
    std::cout << "\n";

    return 0;
}
