#include <stack>
#include <iostream>
#include <vector>

// Imamo klasu red, koja sadrzi 2 privatne promenljive koje su stekovi pomocu kojih se implementira red. Jedan stek sluzi za ulazne podatke tj dodavanje elemenata na kraj reda, i tu cemo samo dodavati element na kraj vrh steka
// Metod pop() odnosno uzimanje elementa sa pocetka reda radi tako sto ako je drugi stek (pop_stack) prazan, moramo da prekopiramo sve elemente iz push steka u pop stek. S obzirom na to kako stek radi, pop stek ce imati obrnut sadrzaj
// u odnosu na push stek, sto nama bas i treba (posto dodajemo na kraj, a skidamo sa pocetka)

/*
    Ako recimo dodajemo u red elemente 5 3 4 

    push_stack:

    4

    3

    5

    Elementi u redu bi trebalo da budu:

    5 3 4

    Skidanje sa pocetka reda treba da nam vrati 5

    Pozivom metoda pop():

    push_stack:            pop_stack:

    prazan                 5 
                    
                           3

                           4

    Skidanjem sa vrha bas dobijamo element 5 sto je i ocekivano ponasanje reda

*/
class queue
{
public:
    queue() {}

    void push(int x) 
    {
        push_stack.push(x);
    }

    int pop() 
    {
        if (pop_stack.empty()) {
            while (!push_stack.empty()) {
                pop_stack.push(push_stack.top());
                push_stack.pop();
            }
        }

        int res = pop_stack.top();
        pop_stack.pop();

        return res;
    }

private:
    std::stack<int> push_stack;
    std::stack<int> pop_stack;
};

int main ()
{
    queue q;

    q.push(1);
    q.push(2);

    std::cout << q.pop() << std::endl;

    q.push(3);  
    
    std::cout << q.pop() << std::endl;

    std::cout << q.pop() << std::endl;

    return 0;
}
