#include <iostream>
#include <queue>
#include <vector>
#include <climits>

int najveci_prosek_v1(int n, int k)
{
    std::vector<int> a(n);

    for (int i = 0; i < n; i++) {
        std::cin >> a[i];
    }

    int suma = 0;

    int max_suma, max_index = 0;

    for (int i = 0; i < k; i++) {
        suma += a[i];
    }

    max_suma = suma;

    for (int i = k; i < n; i++) {
        suma -= a[i - k];
        suma += a[i];
        if (suma > max_suma) {
            max_suma = suma;
            max_index = i - k + 1;
        }
    }

    return max_index;
}

int najveci_prosek_v2(int n, int k)
{
    // Koristicemo red
    std::queue<int> q;

    int x;

    int max_suma, max_index = 0, suma = 0;

    // Dodamo prvih k elemenata u red i racunamo njihovu sumu
    for (int i = 0; i < k; i++) {
        std::cin >> x;
        q.push(x);
        suma += x;
    }

    max_suma = suma;

    // Idemo kroz preostale elemente niza (samo ucitavamo element bez smestanja u niz).
    // U svakom koraku element sa pocetka reda izbacujemo jer on ne pripada narednom segmentu duzine k, a novi element
    // na koji nailazimo dodajemo na kraj reda jer je on deo segmenta.
    for (int i = k; i < n; i++) {
        // Kada uklonimo element sa pocetka i sumu smanjujemo za njegovu vrednost
        suma -= q.front();
        q.pop();

        std::cin >> x;
        // Kada dodamo element na kraj reda, sumu uvecavamo za njegovu vrednost
        q.push(x);
        suma += x;

        // Azuriramo maksimalnu sumu po potrebi
        if (suma > max_suma) {
            max_suma = suma;
            max_index = i - k + 1;
        }
    }

    return max_index;
}

int main ()
{
    int n, k;

    std::cin >> n >> k;

    std::cout << najveci_prosek_v1(n, k) << "\n";

    // std::cout << najveci_prosek_v2(n, k) << "\n";

    return 0;
}