#include <iostream>
#include <queue>
#include <vector>

int main ()
{
    std::priority_queue<int, std::vector<int>, std::greater<int>> heap;

    std::vector<int> a = {15, 80, 25, 60, 10, 20, 50, 45, 40, 30};

    int k = 3, n = a.size();

    // Prvih k elemenata niza smestamo u min heap. Na ovaj nacin kada naidje veci element od minimuma on ce "izbaciti"
    // minimalni element, cime u hipu ostaju samo veci elementi.
    for (int i = 0; i < k; i++) {
        heap.push(a[i]);
    }

    while (heap.size()) {
        std::cout << heap.top() << "\n";
        heap.pop();
    }

    // U svakom koraku poredimo novi element sa vrhom hipa. Ako je element veci, onda on izbacuje minimalni element i novi
    // element ulazi u hip na neku nizu poziciju. Time odrzavamo k najvecih elemenata u hipu
    for (int i = k; i < n; i++) {
        if (a[i] > heap.top()) {
            heap.pop();
            heap.push(a[i]);
        }
    }

    int suma = 0;
    // Na kraju samo uklonimo sve elemente iz hipa (k najvecih) i racunamo njihovu sumu
    while (!heap.empty()) {
        suma += heap.top();
        heap.pop();
    }

    std::cout << suma << "\n";
    return 0;
}